#!/usr/bin/perl


#EasyChat Copyright 1997, David Turley <dturley@pobox.com>

#Ins Deutsche bersetzt von Dan Sepeur
#URL: http://www.tag4tag.com
#Mail: dan@entacle.de

#Sie knnen das Script so benutzen und verndern, solange Sie
#diese Zeilen intakt lassen.
#Sie drfen den Code nicht ohne die ausdrckliche Genehmigung des Autors
#verkaufen.

#Letzte Modifizierung: 17.10.1997r 17, 1997

#Dateiname: chat.cgi

#Editieren Sie die Variablen in diesem Script um Ihre Serverumgebung
#einzustellen.
#Editieren Sie das FORM ACTION in logon.html damit chat.cgi aufgerufen
#wird

#Die Zeilenstruktur von messages.html
#und users.html ist wichtig fr das Script. Nehmen Sie daher an diesen
#Dateien keine nderungen vor.

##Setzen der Variablen:

$msg_html = "/home/www/tag4tag/scripts/chat/easy-chat/messages.html";
$log_file = "/home/www/tag4tag/scripts/chat/easy-chat/log.txt";
$users_html = "/home/www/tag4tag/scripts/chat/easy-chat/users.html";
$script_url = "http://www.tag4tag.com/scripts/chat/easy-chat/chat.cgi";
$home_url = "http://www.tag4tag.com/scripts/chat/easy-chat";

#for demo:
$home_title = "Zurck zu Tag -4- Tag";
$scripts_url = "http://www.tag4tag.com";


###Ende der UserVariablen

&parse_form;

&check_empty;

&get_date;

&get_msg_file;

&write_msg_file;

&make_form;

&update_users;

&log;	##Kommentieren Sie diese Zeile aus, wenn kein LOG gewnscht ist

##get the form data
sub parse_form{
        if ($ENV{'REQUEST_METHOD'} eq 'POST') {
        # Get the input
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
 
        # Split the name-value pairs
        @pairs = split(/&/, $buffer);
      
        #determine name and variable for each pair
        foreach $pair (@pairs) {
                ($name, $value) = split(/=/, $pair);
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
                $value =~ s/<!--(.|\n)*-->//g; 	#removes any server side includes
                $value =~ s/[;><&\*`\|]//g; 	#removes dangerous characters, just to be sure!
                $FORM{$name} = $value;
        }
        
        }
        
        else {          
                &file_error("Can't proccess form");
        }  

}

##make sure they enter a name and don't send blank messages
sub check_empty {
	if (exists $FORM{'hello'}) {
		$user = $FORM{'user'};
		$user =~ s/^\s+//;
		$user =~ s/\s+$//;
			if ($user eq "") {
				print "Content-type: text/html\n";
				print "Pragma: no-cache\n\n";	
				print qq!
				<HTML><BODY BGCOLOR=#20B2AA TEXT=#00008B><CENTER>
				<B>Sie m&uuml;ssen einen Namen f&uuml;r Ihr Login angeben.</B>
				<A HREF="$home_url/logon.html" TARGET="_self">Erneut versuchen</A>
				</BODY></HTML>
				!;
				exit;

			}
	}
	
	$msg = $FORM{'message'};
	$msg =~ s/^\s+//;
	$msg =~ s/\s+$//;
		if (($msg eq "") || ($msg eq "You forgot to enter a message")){
			print "Content-type: text/html\n";
			print "Pragma: no-cache\n\n";
			print qq!
			<HTML><BODY BGCOLOR=#20B2AA TEXT=#00008B><CENTER><TABLE><TR><TD>
			<FORM ACTION="$script_url" METHOD=POST>
			Nachricht:<INPUT TYPE=text NAME=message 
			VALUE='You forgot to enter a message' SIZE=40>
			<INPUT TYPE=hidden NAME=user VALUE="$FORM{'user'}">
			<INPUT TYPE=hidden NAME=font VALUE=$FORM{'font'}>
			<INPUT TYPE=submit VALUE="Absenden"></FORM></TD><TD>
			<FORM ACTION="$script_url" METHOD=POST>
			<INPUT TYPE=hidden NAME=message VALUE='Ausgeloggt am $dateStr'>
			<INPUT TYPE=hidden NAME=user VALUE="$FORM{'user'}">
			<INPUT TYPE=hidden NAME=font VALUE=$FORM{'font'}>
			<INPUT TYPE=hidden NAME=bye VALUE=bye>
			<INPUT TYPE=submit VALUE="Ausloggen">
			</FORM></TD><TD>
			<FORM ACTION="$home_url/users.html" TARGET=messages>
			<INPUT TYPE=submit VALUE="Wer ist hier?">
			</FORM></TD></TR></TABLE></CENTER></BODY></HTML>
			!;
			exit;
		}
	
}
		

sub get_date{
	@days = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
	(undef,$min,$hour,undef,undef,undef,$wday) = localtime(time);

	if ($hour > 11) {
		$ampm='pm';
	}
	else {
		$ampm='am';
	}

	if ($hour > 12) {
		$hour -= 12;
	}

	if ($hour == 0) {
		$hour = 12;
	}

	if ($min < 10) {
		$min = "0$min";
	}

	$dateStr = "$days[$wday], $hour:$min $ampm";
}

## get the message html file
sub get_msg_file {
	open(MAIN, "$msg_html") || die $!;
                @main = <MAIN>;
                close(MAIN);
}


##update the message html file
sub write_msg_file {
	open(MAIN, ">$msg_html") || die $!;
	&lock_file(MAIN);

	print MAIN "<HTML><HEAD><META HTTP-EQUIV=\"Refresh\" CONTENT=\"10\"></HEAD><BODY BGCOLOR=\"#FFFFFF\">";
	print MAIN "\n";

	if (exists $FORM{'hello'}) {
		print MAIN "<P><FONT COLOR=$FORM{'font'}>$FORM{'user'}: $FORM{'message'} $dateStr</FONT>\n";
	}

	else {
		print MAIN "<P><FONT COLOR=$FORM{'font'}>$FORM{'user'}: $FORM{'message'}</FONT>\n";
	}

	for ($i=1; $i<20; $i++) {
		print MAIN "$main[$i]";
	}

	print MAIN "</BODY></HTML>";
	
	close(MAIN);
}


sub make_form {

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n\n";

	if (exists $FORM{'bye'}) {
		print qq!
		<HTML><BODY BGCOLOR=#20B2AA TEXT=#00008B><CENTER>
		<A HREF="$home_url/logon.html" TARGET="_self">Erneut einloggen</A>
		<A HREF="$scripts_url" TARGET="_top">$home_title</A></CENTER>
		</BODY></HTML>
		!;
	}
	
	else {

	print qq!
	<HTML><BODY BGCOLOR=#20B2AA TEXT=#00008B><CENTER><TABLE><TR><TD>
	<FORM ACTION="$script_url" METHOD=POST>
	Nachricht:<INPUT TYPE=text NAME=message SIZE=40>
	<INPUT TYPE=hidden NAME=user VALUE="$FORM{'user'}">
	<INPUT TYPE=hidden NAME=font VALUE=$FORM{'font'}>
	<INPUT TYPE=submit VALUE="Absenden"></FORM></TD><TD>
	<FORM ACTION="$script_url" METHOD=POST>
	<INPUT TYPE=hidden NAME=message VALUE='Ausgeloggt am $dateStr'>
	<INPUT TYPE=hidden NAME=user VALUE="$FORM{'user'}">
	<INPUT TYPE=hidden NAME=font VALUE=$FORM{'font'}>
	<INPUT TYPE=hidden NAME=bye VALUE=bye>
	<INPUT TYPE=submit VALUE="Ausloggen">
	</FORM></TD><TD>
	<FORM ACTION="$home_url/users.html" TARGET=messages><INPUT TYPE=submit VALUE="Wer ist hier?">
	</FORM></TD></TR></TABLE></CENTER></BODY></HTML>
	!;
	}
}


##keep a log of all transactions
sub log {
	open(LOG, ">>$log_file") || die $!;
	&lock_file(LOG);
	
	if (exists $FORM{'hello'}) {
		print LOG "$FORM{'user'}: $FORM{'message'} $dateStr\n";
	}

	else {
		print LOG "$FORM{'user'}: $FORM{'message'}\n";
	}
	
	close(LOG);
}

sub update_users {
	if (exists $FORM{'hello'}) {
		open(USER, "$users_html") || die $!;
		@users = <USER>;
		close(USER);
		unshift(@users,"$FORM{'user'}<BR>\n");
		@users[0,1] = @users[1,0];
		open(USER, ">$users_html");
		&lock_file(USER);
		print USER "@users";
		close USER;
	}
	
	if (exists $FORM{'bye'}) {
		open(USER, "$users_html");
		@users = <USER>;
		close(USER);
		foreach $line (@users) {
			if ($line =~ s!^\s*$FORM{'user'}<BR>\s*$!!) {
				last;		#find only first occurance in case multiple users with same name
			}
		}

	open(USER, ">$users_html");
	&lock_file(USER);
	print USER "@users";
	close(USER);
	}	
	
}

sub file_error {
        $error_message = $_[0];
        print "Content-type: text/html\n\n";
        print "<HTML><HEAD>\n";
        print "<TITLE>Dateifehler</TITLE></HEAD>\n";
        print "<BODY>Es gab einen Fehler beim &Ouml;ffnen des Chats.\n";
        print "<BR>Fehler = $error_message\n";
  
        print "<BR></BODY></HTML>"; 
        exit;
}

sub lock_file {
	$LOCK = 2;
	flock($_[0], $LOCK);
}

